<script setup lang="ts">
import { ref } from 'vue'
import { useRoute } from 'vue-router'
import { useStore } from 'vuex'
import PipelineSetupForm from '@/components/gitlab/pipeline/setup/PipelineSetupForm.vue'
import GitApi from '@/api/gitApi'

// Props
const routeProp = defineProps({
  origin: {
    type: String,
    default: 'vendors',
  },
})

// Refs
const user = ref({ username: '', rol: '' })
const branches = ref<Array<{ value: string; text: string }>>([])
const branch = ref('main')
const groupId = ref(0)
const projectId = ref(0)
const project = ref({})

// Hooks
const store = useStore()
const route = useRoute()

// Methods
const getProject = async () => {
  const gitApi = new GitApi()
  try {
    const response = await gitApi.getSingleProject(projectId.value.toString())

    project.value = response.data
    console.log('getProject project.value:', project.value)
  }
  catch (error) {
    console.error('getProject error: ', error)
  }
}

const editProjectLink = async () => {
  const gitApi = new GitApi()
  const response = ref('')
  try {
    response.value = await gitApi.editProjectLink(projectId.value.toString(), branch.value)
    window.open(response.value, '_blank')
    console.log('link to edit project:', response.value)
  }
  catch (error) {
    console.error('getProject error: ', error)
  }

  return response.value
}

const getBranches = async () => {
  const gitApi = new GitApi()
  try {
    const response = await gitApi.getBranches(projectId.value.toString())

    console.log('getBranches: response.data', response.data)
    branches.value = response.data.map((branch: { name: string }) => ({
      value: branch.name,
      text: branch.name,
    }))
    console.log('getBranches branches.value:', branches.value)
  }
  catch (error) {
    console.error('getBranches error: ', error)
  }
}

watch(branch, (newValue, oldValue) => {
  console.log('[pipelineSetupComponent] Branch changed from', oldValue, 'to', newValue)
  if (newValue)
    localStorage.setItem('selectedBranch', newValue)
})

onBeforeMount(() => {
  user.value = store.state.user
  groupId.value = route.params.id as any
  projectId.value = route.params.projectId as any

  const savedBranch = localStorage.getItem('selectedBranch')
  if (savedBranch)
    branch.value = savedBranch

  getProject()
  getBranches()
})
</script>

<template>
  <VCard>
    <!-- CARD HEADER -->
    <VCardTitle>
      <VRow class="d-flex justify-space-between align-center">
        <VCol
          class="me-auto"
          cols="auto"
        >
          <VIcon
            class="mr-2"
            size="18"
          >
            tabler-briefcase
          </VIcon>
          {{ project.name }}
        </VCol>
        <VCol
          v-if="['developer', 'root'].includes(user.rol.toLowerCase())"
          cols="auto"
        >
          <VSelect
            v-model="branch"
            :items="branches"
            item-title="text"
            label="Branches"
            prepend-inner-icon="tabler-git-branch"
            dense
            outlined
          />
        </VCol>
        <VCol cols="auto">
          <VBtn
            v-if="['developer', 'root'].includes(user.rol.toLowerCase())"
            variant="tonal"
            color="cyan"
            rounded="lg"
            size="38"
            elevation="2"
            @click="editProjectLink"
          >
            <VIcon
              size="22px"
              color="cyan"
            >
              tabler-brand-vscode
            </VIcon>
            <VTooltip
              bottom
              activator="parent"
              location="bottom"
            >
              edit project
            </VTooltip>
          </VBtn>
        </VCol>
      </VRow>
    </VCardTitle>
    <VDivider
      color="primary"
      thickness="2"
      class="border-opacity-50"
    />
    <!-- END CARD HEADER -->

    <!-- CARD BODY -->
    <VCardText>
      <!-- <p>Description: {{ project.description }}</p> -->
      <PipelineSetupForm
        :group-id="groupId"
        :project-id="projectId"
        :branch="branch"
        :route="origin"
      />
    </VCardText>
    <!-- END CARD BODY -->
  </VCard>
</template>

<style scoped></style>
